%define major 2
%define libname %mklibname drm %{major}
%define develname %mklibname drm -d
%define staticdevelname %mklibname drm -d -s

%define intel_major 1
%define libintel %mklibname drm_intel %{intel_major}
%define nouveau_major 1
%define libnouveau %mklibname drm_nouveau %{nouveau_major}
%define radeon_major 1
%define libradeon %mklibname drm_radeon %{radeon_major}

Summary:	Userspace interface to kernel DRM services
Name:		libdrm
Version:	2.4.14
Release:	%mkrel 2
Group:		System/Libraries
License:	MIT/X11
URL:		http://xorg.freedesktop.org
Source0:	http://dri.freedesktop.org/libdrm/libdrm-%{version}.tar.bz2
Source1: 91-drm-modeset.rules

Patch0100:  0100-RH-libdrm-make-dri-perms-okay-v1.1.patch
Patch0101:  0101-RH-libdrm-2.4.0-no-bc-v1.3.patch

Patch0500:  0500-improve-waiting-for-dri-device-to-appear-when-system.patch

Patch1005:     libdrm_mips_drm_cas.patch
Patch1006:     libdrm_mips_sarea_max.patch

BuildRequires:	kernel-headers >= 1:2.6.27.4-3mnb2
BuildRequires:	libpthread-stubs
BuildRequires:	x11-util-macros >= 1.0.1
BuildRequires: udev-devel
Conflicts:	kernel-headers <= 1:2.6.27.4-2mnb2
BuildRoot:	%{_tmppath}/%{name}-root

%description
Userspace interface to kernel DRM services

%package common
Summary:	Common files for the userspace interface to kernel DRM services
Group:		System/Libraries

%description common
Common files for the userspace interface to kernel DRM services

%package -n	%{libname}
Summary:	Userspace interface to kernel DRM services
Group:		System/Libraries
Provides:	%{name} = %{version}
Requires: %{name}-common

%description -n	%{libname}
Userspace interface to kernel DRM services

%package -n	%{libintel}
Summary:	Shared library for Intel kernel DRM services
Group:		System/Libraries
Conflicts:	%{_lib}drm2 < 2.4.5-2

%description -n %{libintel}
Shared library for Intel kernel Direct Rendering Manager services.

%package -n	%{libnouveau}
Summary:	Shared library for Nouveau kernel DRM services
Group:		System/Libraries

%description -n %{libnouveau}
Shared library for Nouveau kernel Direct Rendering Manager services.

%package -n	%{libradeon}
Summary:	Shared library for Radeon kernel DRM services
Group:		System/Libraries
Conflicts:	%{_lib}drm2 < 2.4.5-2

%description -n %{libradeon}
Shared library for Radeon kernel Direct Rendering Manager services.

%package -n	%{develname}
Summary:	Development files for %{name}
Group:		Development/X11
Requires:	%{libname} = %{version}
Requires:	%{libintel} = %{version}
Requires:	%{libnouveau} = %{version}
Requires:	%{libradeon} = %{version}
Provides:       %{name}-devel = %{version}-%{release}
Obsoletes:      %{mklibname drm 2 -d}
Obsoletes:	drm-nouveau-devel < 2.3.0-2.20090111.2

%description -n	%{develname}
Development files for %{name}

%package -n	%{staticdevelname}
Summary:	Static development files for %{name}
Group:		Development/X11
Requires:	%{name}-devel >= %{version}
Requires:	%{libname} = %{version}
Provides:       %{name}-static-devel = %{version}-%{release}
Obsoletes:      %{mklibname drm 2 -d -s}

%description -n	%{staticdevelname}
Static development files for %{name}

%prep

%setup -q
%apply_patches

%build
# Needed for patch4
autoreconf -fv --install
%configure2_5x \
    --enable-udev \
    --enable-static \
    --enable-nouveau-experimental-api \
    --enable-radeon-experimental-api

%make

%install
rm -rf %{buildroot}

%makeinstall_std 
mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d/
install -m 0644 %{SOURCE1} %{buildroot}%{_sysconfdir}/udev/rules.d/

find %{buildroot} -type f -name '*.la' -exec rm -f {} \;

# (cg) Note that RH remove drm.h drm_mode.h drm_sarea.h r300_reg.h via_3d_reg.h
# and we should perhaps do the same? (previous attempts have not gone well :)

%if %mdkversion < 200900
%post -n %{libname} -p /sbin/ldconfig
%endif

%if %mdkversion < 200900
%postun -n %{libname} -p /sbin/ldconfig
%endif

%clean
rm -rf %{buildroot}

%files common
%defattr(-,root,root)
%{_sysconfdir}/udev/rules.d/91-drm-modeset.rules

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libdrm.so.%{major}*

%files -n %{libintel}
%defattr(-,root,root)
%{_libdir}/libdrm_intel.so.%{intel_major}*

%files -n %{libnouveau}
%defattr(-,root,root)
%{_libdir}/libdrm_nouveau.so.%{nouveau_major}*

%files -n %{libradeon}
%defattr(-,root,root)
%{_libdir}/libdrm_radeon.so.%{radeon_major}*

%files -n %{develname}
%defattr(-,root,root)
%{_includedir}/drm
%{_includedir}/nouveau
%{_includedir}/*.h
%{_libdir}/libdrm*.so
%{_libdir}/pkgconfig/libdrm*.pc

%files -n %{staticdevelname}
%defattr(-,root,root)
%{_libdir}/*.a


%changelog
* Sun Sep 27 2009 Olivier Blin <oblin@mandriva.com> 2.4.14-2mdv2010.0
+ Revision: 449859
- add mips patches (from Arnaud Patard)

* Wed Sep 23 2009 Thierry Vignaud <tvignaud@mandriva.com> 2.4.14-1mdv2010.0
+ Revision: 447709
- new release

* Thu Sep 17 2009 Thierry Vignaud <tvignaud@mandriva.com> 2.4.13-2mdv2010.0
+ Revision: 443997
- radeon: fix 32/64 bit issue with sign extension

* Mon Aug 31 2009 Thierry Vignaud <tvignaud@mandriva.com> 2.4.13-1mdv2010.0
+ Revision: 422872
- new release

* Sun Aug 02 2009 Anssi Hannula <anssi@mandriva.org> 2.4.12-2mdv2010.0
+ Revision: 407529
- update nouveau library to git snapshot

* Fri Jul 24 2009 Anssi Hannula <anssi@mandriva.org> 2.4.12-1mdv2010.0
+ Revision: 399497
- new version 2.4.12
- fix underlinking in libdrm_intel (intel-underlinking.patch)
- drop radeon patch, applied upstream (with configure option)
- remove unused patches

* Wed May 20 2009 Colin Guthrie <cguthrie@mandriva.org> 2.4.11-1mdv2010.0
+ Revision: 378087
- New version: 2.4.11
- BuildRequire udev-devel
- Use %%apply_patches

* Sun May 10 2009 Colin Guthrie <cguthrie@mandriva.org> 2.4.9-3mdv2010.0
+ Revision: 374013
- Include a couple of intel fixes from upstream
- Remove old file not referenced in SPEC

* Wed Apr 22 2009 Frederic Crozat <fcrozat@mandriva.com> 2.4.9-2mdv2009.1
+ Revision: 368623
- Increase timeout for dri detection, in speedboot mode only (Mdv bug #49490)

* Thu Apr 16 2009 Colin Guthrie <cguthrie@mandriva.org> 2.4.9-1mdv2009.1
+ Revision: 367601
- New version: 2.4.9
- Drop nouveau headers patch (fixed upstream)

* Fri Apr 10 2009 Anssi Hannula <anssi@mandriva.org> 2.4.9-0.1mdv2009.1
+ Revision: 365759
- obsolete drm-nouveau-devel in correct package

* Wed Apr 08 2009 Frederic Crozat <fcrozat@mandriva.com> 2.4.5-8mdv2009.1
+ Revision: 365194
- Enable patch 5 again, but use upstream timing

* Wed Apr 08 2009 Frederic Crozat <fcrozat@mandriva.com> 2.4.5-7mdv2009.1
+ Revision: 365159
- Disable patch6, it is causing 1min timeout on some systems

* Wed Apr 08 2009 Frederic Crozat <fcrozat@mandriva.com> 2.4.5-6mdv2009.1
+ Revision: 365113
- Patch5: improve wait on dri devices when system is busy (Mdv bug #49490)

* Tue Mar 31 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.4.5-5mdv2009.1
+ Revision: 362770
- Remove bad worded and unecessary /etc/modprobe.d/i915modeset
  (also it prevents passing custom options to i915 using modprobe)

* Mon Mar 02 2009 Anssi Hannula <anssi@mandriva.org> 2.4.5-4mdv2009.1
+ Revision: 347410
- enable experimental nouveau api
- add missing nouveau headers (missing-nouveau-headers.patch)

* Mon Mar 02 2009 Anssi Hannula <anssi@mandriva.org> 2.4.5-3mdv2009.1
+ Revision: 347380
- fix requires of devel package

* Sun Mar 01 2009 Anssi Hannula <anssi@mandriva.org> 2.4.5-2mdv2009.1
+ Revision: 346373
- own /usr/include/drm
- split libdrm_intel and libdrm_radeon, their major differs
- fix group
- drop duplicate requires
- ensure major correctness
- devel obsoletes drm-nouveau-devel

* Wed Feb 25 2009 Colin Guthrie <cguthrie@mandriva.org> 2.4.5-1mdv2009.1
+ Revision: 344967
- New version: 2.4.5
- Drop upstream patches

* Tue Feb 17 2009 Ander Conselvan de Oliveira <ander@mandriva.com> 2.4.4-2mdv2009.1
+ Revision: 342152
- Cherry pick "intel: libdrm support for fence management in execbuf" from master.
  This is needed to enable tiled rendering on intel pre-i965 hardware (cf.
  svn revision 342151 for intel driver).

* Thu Jan 15 2009 Colin Guthrie <cguthrie@mandriva.org> 2.4.4-1mdv2009.1
+ Revision: 329701
- New version: 2.4.4

* Tue Dec 30 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.3-2mdv2009.1
+ Revision: 321372
- Fix bogus provides

* Tue Dec 30 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.3-1mdv2009.1
+ Revision: 321331
- Update to 2.4.3
- Enable udev support
- Liberate patches from Fedora
- Install udev rules for permissions
- Allow activation of kernel modesetting via kernel cmdline

* Sun Nov 16 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.4.1-9mdv2009.1
+ Revision: 303789
- Conflicts with kernel-headers package because of headers being
  provided again by libdrm.

* Thu Nov 13 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.1-8mdv2009.1
+ Revision: 302923
- Install all headers (the ones from kernel-headers are, like, so last season)

* Tue Nov 04 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.4.1-7mdv2009.1
+ Revision: 299839
- Rebuild because of eaten static-devel package in latest submit.

* Mon Nov 03 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.4.1-6mdv2009.1
+ Revision: 299592
- libdrm-devel: remove files provided by kernel-headers.

* Mon Nov 03 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.4.1-5mdv2009.1
+ Revision: 299588
- Fix buildrequires version match for kernel-headers.

* Mon Nov 03 2008 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 2.4.1-4mdv2009.1
+ Revision: 299580
- Rebuild with kernel-headers 2.6.27.4-1mnb2

* Sun Nov 02 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.1-3mdv2009.1
+ Revision: 299245
- Unrevert the symbol change commit (intel driver just needs rebuild)

* Sat Nov 01 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.1-2mdv2009.1
+ Revision: 299165
- Fix a crash by reverting upstream commit (for now)

* Sat Nov 01 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.1-1mdv2009.1
+ Revision: 299139
- New version: 2.4.1

* Mon Oct 27 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.0-2mdv2009.1
+ Revision: 297741
- Prevent a lockup in intel_bufmgr_fake

* Tue Oct 21 2008 Colin Guthrie <cguthrie@mandriva.org> 2.4.0-1mdv2009.1
+ Revision: 295881
- Add missing buildrequire for libpthread-stubs
- New version: 2.4.0

* Thu Jul 24 2008 Ander Conselvan de Oliveira <ander@mandriva.com> 2.3.1-1mdv2009.0
+ Revision: 245954
- Update to verseion 2.3.1

* Tue Jun 17 2008 Thierry Vignaud <tvignaud@mandriva.com> 2.3.0-8mdv2009.0
+ Revision: 222535
- rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Revert build requires.

* Mon Jan 14 2008 Paulo Andrade <pcpa@mandriva.com.br> 2.3.0-7mdv2008.1
+ Revision: 151897
- Update BuildRequires and rebuild.
  Also disable patch1 as it is being used just to "document" functions called
  from the X Server.

* Sun Jan 13 2008 Thierry Vignaud <tvignaud@mandriva.com> 2.3.0-6mdv2008.1
+ Revision: 150691
- BuildRequires x11-proto-devel for X11/Xfuncproto.h
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Paulo Andrade <pcpa@mandriva.com.br>
    - Initial listing of symbols required by the ati driver. This is for now a noop
      patch as libraries at first will have all symbols visible.

* Fri Aug 31 2007 Oden Eriksson <oeriksson@mandriva.com> 2.3.0-4mdv2008.0
+ Revision: 76972
- cleanup borked deps

* Fri Aug 31 2007 Oden Eriksson <oeriksson@mandriva.com> 2.3.0-3mdv2008.0
+ Revision: 76831
- new devel name


* Wed Mar 21 2007 Gustavo Pichorim Boiko <boiko@mandriva.com> 2.3.0-2mdv2007.1
+ Revision: 147232
- When checking wheter to change owner or not, serv_group is unsigned.

* Tue Nov 14 2006 Thierry Vignaud <tvignaud@mandriva.com> 2.3.0-1mdv2007.1
+ Revision: 84141
- new release

* Thu Jun 29 2006 Gustavo Pichorim Boiko <boiko@mandriva.com> 2.0.2-1mdv2007.0
+ Revision: 38128
- new upstream version (2.0.2):
   * Updated kernel DRM headers
- rebuild to fix cooker uploading
- X11R7.1
- renaming the specfile as well
- renaming the package to its right name (without the soname)
- do not use soname in the srpm
- Adding X.org 7.0 to the repository

  + Frederic Crozat <fcrozat@mandriva.com>
    - Patch0: do not change permission if not requested
    - call ldconfig on lib package install/removal

  + Andreas Hasenack <andreas@mandriva.com>
    - renamed mdv to packages because mdv is too generic and it's hosting only packages anyway

  + Thierry Vignaud <tvignaud@mandriva.com>
    - fix license

